#include "models.h"
#include "structs.h"
#include <GL/glut.h>

#include "defines.h"

struct vec3 boxSize = {2.0,2.0,2.0};
struct vec3 boxPos = {0.0, 0.0, -7.0};
struct vec3 velocity = {0.07, 0.08, -0.075};
float boundingBox[6] = {-4.0,4.0,-4.0,4.0,-10.0,-4.0};

float teapotSize = 1.0;
//struct vec3 teapotPos = {-0.5, 0.9, -3.2};
struct vec3 teapotPos = {0.0, 0.0, -7.0};
struct vec3 teapotVelocity = {0.07, 0.08, -0.075};
float teapotBounds[6] = {-4.0,4.0,-4.0,4.0,-10.0,-4.0};

float cubeSize = 4.0;
struct vec3 cubePos = {4.9, 4.9, -6.0};
struct vec3 cubeVelocity = {0.07, 0.08, -0.5};
float cubeBounds[6] = {-5.0,9.0,-5.0,9.0,-18.0,-2.0};

int test = 0;



/***********************
Move object in the scene
************************/
void moveObj(float dx, float dy, float dz)
{
	boxPos.x += dx;
	boxPos.y += dy;
	boxPos.z += dz;
	teapotPos.x += dx;
	teapotPos.y += dy;
	teapotPos.z += dz;
	cubePos.x += dx;
	cubePos.y += dy;
	cubePos.z += dz;
}



/***********************
Draw models in the scene
************************/
void drawCubes()
{
	for(int i=0; i<200; i++)
	{
		glPushMatrix();
			drawCube();
		glPopMatrix();
	}

}

void drawCube()
{


	// adding extra vertices for the vertex transformation
	float scaleDetail = 0.05;
	int detail = 16;
	float distanceToCOP = 1.0 - cubePos.z;
	#if (METHOD==2)
		if(distanceToCOP > -0.75) detail = (int)(floor(WIDTH * scaleDetail * cubeSize/distanceToCOP));

		//detail = 800;

	#else
		detail = 1;
	#endif

	if(test==0){
		test = 1;
		std::cout<<"number of extra vertices on each line: "<<detail<<"\n";
	}

	float vertDist = cubeSize/((float) detail);

	float tempPosx,tempPosy,tempPosz;

    glPushMatrix();

	glBegin(GL_POLYGON);

        // This is the front face
		glColor3f(0.2f,0.2f,0.6f);
        glVertex3f(cubePos.x, cubePos.y, cubePos.z);

		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x - vertDist * i, cubePos.y, cubePos.z);

		tempPosx = cubePos.x - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx, cubePos.y - vertDist * i, cubePos.z);

		tempPosy = cubePos.y - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx + vertDist * i, tempPosy, cubePos.z);

		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x, tempPosy  + vertDist * i, cubePos.z);

	glEnd();


	glBegin(GL_POLYGON);

        // This is the right face
		glColor3f(0.0f,1.0f,0.0f);
        glVertex3f(cubePos.x, cubePos.y, cubePos.z);

		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x, cubePos.y - vertDist * i, cubePos.z);

		tempPosy = cubePos.y - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x, tempPosy, cubePos.z - vertDist * i);

		tempPosz = cubePos.z - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x, tempPosy + vertDist * i, tempPosz);

		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x, cubePos.y, tempPosz  + vertDist * i);

	glEnd();

	glBegin(GL_POLYGON);

        // This is the left face
		glColor3f(0.2f,0.6f,0.2f);
		tempPosx = cubePos.x - cubeSize;
        glVertex3f(tempPosx, cubePos.y, cubePos.z);

		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx, cubePos.y, cubePos.z - vertDist * i);

		tempPosz = cubePos.z - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx, cubePos.y - vertDist * i, tempPosz);

		tempPosy = cubePos.y - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx, tempPosy, tempPosz + vertDist * i);

		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx, tempPosy + vertDist * i, cubePos.z);

	glEnd();

	glBegin(GL_POLYGON);

		// This is the top face
		glColor3f(1.0f,0.0f,0.0f);
		glVertex3f(cubePos.x, cubePos.y, cubePos.z);

		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x, cubePos.y, cubePos.z - vertDist * i);

		tempPosz = cubePos.z - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x - vertDist * i, cubePos.y, tempPosz);

		tempPosx = cubePos.x - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx, cubePos.y, tempPosz + vertDist * i);

		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx + vertDist * i, cubePos.y, cubePos.z);


	glEnd();

	glBegin(GL_POLYGON);

        // This is the bottom face
		glColor3f(0.6f,0.2f,0.2f);
		tempPosy = cubePos.y - cubeSize;
        glVertex3f(cubePos.x, tempPosy, cubePos.z);

		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x, tempPosy, cubePos.z - vertDist * i);

		tempPosz = cubePos.z - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x - vertDist * i, tempPosy, tempPosz);

		tempPosx = cubePos.x - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx, tempPosy, tempPosz + vertDist * i);

		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx + vertDist * i, tempPosy, cubePos.z);


	glEnd();


	glBegin(GL_POLYGON);

        // This is the back face
		glColor3f(0.5f,0.0f,0.5f);
		tempPosz = cubePos.z - cubeSize;
        glVertex3f(cubePos.x, cubePos.y, tempPosz);

		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x - vertDist * i, cubePos.y, tempPosz);

		tempPosx = cubePos.x - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx, cubePos.y - vertDist * i, tempPosz);

		tempPosy = cubePos.y - cubeSize;
		for(int i=1; i<detail+1; i++)
			glVertex3f(tempPosx + vertDist * i, tempPosy, tempPosz);

		for(int i=1; i<detail+1; i++)
			glVertex3f(cubePos.x, tempPosy + vertDist * i, tempPosz);

    glEnd();

    glPopMatrix();
}


void drawBox()
{
	GLfloat color1[4] = { 0.5f, 0.7f, 0.2f, 1.0f };
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, color1);

	glPushMatrix();
		glTranslatef(boxPos.x,boxPos.y,boxPos.z);
		glutSolidCube((GLdouble)boxSize.x);
	glPopMatrix();
}


void scaleTest()
{
	int numBoxes = VERT_SCALE;
	for(int i=0; i<numBoxes; i++)
	{
		drawBox();
	}
}


void drawTeapot()
{
	GLfloat color1[4] = { 0.7f, 0.2f, 0.0f, 1.0f };
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, color1);

	glPushMatrix();
		glTranslatef(teapotPos.x,teapotPos.y,teapotPos.z);
		glutSolidTeapot((GLdouble)teapotSize);
	glPopMatrix();
}



/***********************
Animate models on the scene
************************/
void moveCube()
{
	cubePos.x += cubeVelocity.x;
	cubePos.y += cubeVelocity.y;
	cubePos.z += cubeVelocity.z;

	if(cubePos.x - cubeSize < cubeBounds[0]
	 || cubePos.x + cubeSize > cubeBounds[1])
	{
	  cubeVelocity.x = -cubeVelocity.x;
	  cubePos.x += cubeVelocity.x;
	}
	if(cubePos.y - cubeSize < cubeBounds[2]
	 || cubePos.y + cubeSize > cubeBounds[3])
	{
	  cubeVelocity.y = -cubeVelocity.y;
	  cubePos.y += cubeVelocity.y;
	}
	if(cubePos.z - cubeSize < cubeBounds[4]
	 || cubePos.z + cubeSize > cubeBounds[5])
	{
	  cubeVelocity.z = -cubeVelocity.z;
	  cubePos.z += cubeVelocity.z;
	}
}


void moveTeapot()
{
	teapotPos.x += teapotVelocity.x;
	teapotPos.y += teapotVelocity.y;
	teapotPos.z += teapotVelocity.z;

	if(teapotPos.x - teapotSize < teapotBounds[0]
	 || teapotPos.x + teapotSize > teapotBounds[1])
	{
	  teapotVelocity.x = -teapotVelocity.x;
	  teapotPos.x += teapotVelocity.x;
	}
	if(teapotPos.y - teapotSize < teapotBounds[2]
	 || teapotPos.y + teapotSize > teapotBounds[3])
	{
	  teapotVelocity.y = -teapotVelocity.y;
	  teapotPos.y += teapotVelocity.y;
	}
	if(teapotPos.z - teapotSize < teapotBounds[4]
	 || teapotPos.z + teapotSize > teapotBounds[5])
	{
	  teapotVelocity.z = -teapotVelocity.z;
	  teapotPos.z += teapotVelocity.z;
	}
}


void moveBox()
{
  boxPos.x += velocity.x;
  boxPos.y += velocity.y;
  boxPos.z += velocity.z;

  if(boxPos.x-boxSize.x < boundingBox[0]
     || boxPos.x + boxSize.x > boundingBox[1])
    {
      velocity.x = -velocity.x;
      boxPos.x += velocity.x;
    }
  if(boxPos.y-boxSize.y < boundingBox[2]
     || boxPos.y + boxSize.y > boundingBox[3])
    {
      velocity.y = -velocity.y;
      boxPos.y += velocity.y;
    }
  if(boxPos.z-boxSize.z < boundingBox[4]
     || boxPos.z + boxSize.z > boundingBox[5])
    {
      velocity.z = -velocity.z;
      boxPos.z += velocity.z;
    }
}

void staticScene()
{
	GLfloat color1[4] = { 0.2f, 0.4f, 0.8f, 1.0f };
	GLfloat color2[4] = { 0.4f, 0.8f, 0.2f, 1.0f };
	GLfloat color3[4] = { 0.8f, 0.2f, 0.4f, 1.0f };
	GLfloat color4[4] = { 0.4f, 0.3f, 0.9f, 1.0f };
	GLfloat color5[4] = { 0.7f, 0.5f, 0.2f, 1.0f };




	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, color1);
	glPushMatrix();
		glTranslatef(-5.2,5.4,-8.0);
		glutSolidTeapot(1.0);
	glPopMatrix();


	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, color2);
	glPushMatrix();
		glTranslatef(3.8,2.5,-7.0);
		glutSolidCube(2.0);
	glPopMatrix();

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, color3);
	glPushMatrix();
		glTranslatef(2.9,-2.1,-4.7);
		glRotatef(215.0,1.0,1.0,0.0);
		glutSolidCone(1.0,2.0,25,25);
	glPopMatrix();

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, color5);
	glPushMatrix();
		glTranslatef(-0.3,-0.2,-11.0);
		glRotatef(125.0,1.0,0.0,0.1);
		glutSolidTorus(0.8,1.8,25,25);
	glPopMatrix();

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, color4);
	glPushMatrix();
		glTranslatef(-2.2,-1.0,-4.0);
		//glRotatef(125.0,1.0,0.0,0.1);
		glutSolidSphere(0.5,25,25);
	glPopMatrix();

}