uniform vec3 P;
uniform vec3 COP;

//for lighting
varying vec4 diffuse,ambient;
varying vec3 normal,lightDir,halfVector;
	
void main(void)
{
	//input:
	//COP
	float xo = COP.x;
	float yo = COP.y;
	float zo = COP.z;
	
	//P
	float xj = P.x;
	float yj = P.y;
	float zj = P.z;

	float R = 1.0;
	float R2 = R * R;
	
	float zp = 0.0;
	
	vec4 oldVertex = gl_ModelViewMatrix * gl_Vertex;

	float xb = -oldVertex.x;
	float yb = oldVertex.y;
	float zb = -oldVertex.z;
	
	// Simplifying expressions
	float xo_xb = xo - xb;
	float yo_yb = yo - yb;
	float zo_zb = zo - zb;
	
	float xo_xb2 = xo_xb * xo_xb;
	float zo_zb2 = zo_zb * zo_zb;
	
	float xo2 = xo * xo;
	float xb2 = xb * xb;
	float zo2 = zo * zo;
	float zb2 = zb * zb;

	float xbxo = xb * xo;
	float xbzo = xb * zo;
	float xozb = xo * zb;
	float zbzo = zb * zo;
	
	float a, b, c, d, z;
	
	if(yb<0.0)
	{
		a = xo_xb2 + zo_zb2;
		b = 2.0 * xo_xb * (xbzo - xozb);
		c = xb2 * zo2 - 2.0 * xbzo * xozb + xo2 * zb2 - R2 * zo_zb2;

		z = (-b - sqrt(b * b - 4.0 * a * c)) / (2.0 * a);
	}
	else
	{
		float yo_yb2 = yo_yb * yo_yb;

		float yo2 = yo * yo;
		float yb2 = yb * yb;

		float ybyo = yb * yo;
		float xoyb = xo * yb;
		float xbyo = xb * yo;
	
		a = xo_xb2 + yo_yb2 + zo_zb2;
		b = zo * (xb2 - xbxo - yb * yo_yb)
		    + zb * (xo2 - xbxo + yo * yo_yb);
		d = zo_zb2 * (zo2 * (R2 - xb2 - yb2) - 2.0 * zbzo * (R2 - xbxo - ybyo)
			- (xoyb - xbyo) * (xoyb - xbyo) + zb2 * (R2 - xo2 - yo2)
			+ R2 * (xo_xb2 + yo_yb2));
		
		z = (b - sqrt(d)) / a;
	}

	// Find x and xp
	float x = (xbzo - xozb + z * xo_xb) / zo_zb;
	float xp = (x *(zj - zp) + xj * (zp - z)) / (zj - z);
	
	// Find y and yp
	float y = (-yo_yb) * sqrt(((zo - z) * (zo - z) + (xo - x) * (xo - x)) / (zo_zb2 + xo_xb2)) + yo;
	float yp = (y - yj) * sqrt(((zj - zp) * (zj - zp) + (xp - xj) * (xp - xj)) / ((zj - z) * (zj - z) + (x - xj) * (x - xj))) + yj;

	vec4 projectionPoint;
	projectionPoint.x = xp;
	projectionPoint.y = yp;
	projectionPoint.z = zb/100.0;
	projectionPoint.w = oldVertex.w;
	
	gl_Position =  projectionPoint;
	
	// for lighting
	normal = normalize(gl_NormalMatrix * gl_Normal);
	lightDir = normalize(vec3(gl_LightSource[0].position));
	//halfVector = normalize(gl_LightSource[0].halfVector.xyz);
	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	//ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;
	
	gl_FrontColor = gl_Color;
} 